"""Database changes for system robustness upgrade.

Revision ID: 1b49271b5b4f
Revises: 35a9589296f9
Create Date: 2022-07-07 13:55:22.211421

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = '1b49271b5b4f'
down_revision = '35a9589296f9'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('cohort',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('label', sa.VARCHAR(length=100), nullable=False),
        sa.Column('description', sa.Text(), nullable=True),
        sa.PrimaryKeyConstraint('id'),
        sa.UniqueConstraint('label')
    )

    op.create_table('external_cohort_urls',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('url', sa.VARCHAR(length=1024), nullable=True),
        sa.Column('cohort_id', sa.Integer(), nullable=True),
        sa.Column('external_system_id', sa.Integer(), nullable=True),
        sa.ForeignKeyConstraint(['cohort_id'], ['cohort.id'], name='fk_external_cohort_links_cohort_id_cohort'),
        sa.ForeignKeyConstraint(['external_system_id'], ['external_system.id'], name='fk_external_cohort_urls_external_system_id_external_system'),
        sa.PrimaryKeyConstraint('id')
    )

    op.create_table('external_system_history',
        sa.Column('id', sa.INTEGER(), nullable=False),
        sa.Column('system_id', sa.INTEGER(), nullable=False),
        sa.Column('timestamp', sa.DateTime(timezone=True), nullable=True),
        sa.Column('url', sa.Text(), nullable=True),
        sa.ForeignKeyConstraint(['system_id'], ['external_system.id'], ),
        sa.PrimaryKeyConstraint('id')
    )

    op.create_table('callback',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('state_id', sa.Integer(), nullable=True),
        sa.Column('label', sa.VARCHAR(length=128), nullable=True),
        sa.Column('function', sa.VARCHAR(length=128), nullable=False),
        sa.Column('callback_arguments', sa.Text(), nullable=True),
        sa.Column('run_timeout', sa.Integer(), nullable=True),
        sa.Column('wait_timeout', sa.Integer(), nullable=True),
        sa.Column('initial_delay', sa.Integer(), nullable=True),
        sa.Column('description', sa.Text(), nullable=True),
        sa.Column('condition', sa.Text(), nullable=True),
        sa.ForeignKeyConstraint(['state_id'], ['state.id'], name='fk_callback_state_id_state'),
        sa.PrimaryKeyConstraint('id')
    )

    op.create_table('variable',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('experiment_id', sa.Integer(), nullable=True),
        sa.Column('label', sa.VARCHAR(length=255), nullable=True),
        sa.Column('type', sa.Enum('none', 'bool', 'int', 'float', 'str', 'date', 'datetime', 'time', 'json', name='variabletype'), nullable=False),
        sa.Column('value', sa.Text(), nullable=True),
        sa.ForeignKeyConstraint(['experiment_id'], ['experiment.id'], name='fk_variable_experiment_id_experiment'),
        sa.PrimaryKeyConstraint('id')
    )

    op.create_table('callback_execution',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('callback_id', sa.Integer(), nullable=True),
        sa.Column('action_id', sa.Integer(), nullable=True),
        sa.Column('status', sa.Enum('created', 'skipped', 'queued', 'running', 'waiting', 'done', name='callbackexecutionstatus'), nullable=True),
        sa.Column('result', sa.Enum('none', 'success', 'failed', 'timeout', name='callbackexecutionresult'), nullable=True),
        sa.Column('run_log', sa.Text(), nullable=True),
        sa.Column('result_log', sa.Text(), nullable=True),
        sa.Column('result_values', sa.Text(), nullable=True),
        sa.Column('secret_key', sa.VARCHAR(length=256), nullable=True),
        sa.Column('created', sa.DateTime(timezone=True), nullable=True),
        sa.Column('run_start', sa.DateTime(timezone=True), nullable=True),
        sa.Column('wait_start', sa.DateTime(timezone=True), nullable=True),
        sa.Column('finished', sa.DateTime(timezone=True), nullable=True),
        sa.ForeignKeyConstraint(['action_id'], ['action.id'], name='fk_callbackexecution_action_id_action'),
        sa.ForeignKeyConstraint(['callback_id'], ['callback.id'], name='fk_callbackexecution_callback_id_callback'),
        sa.PrimaryKeyConstraint('id')
    )

    op.drop_table('transition_has_condition')
    op.drop_table('condition')

    op.drop_column('state', 'lifespan')
    op.drop_column('state', 'callback')

    op.add_column('subject', sa.Column('cohort_id', sa.Integer(), nullable=True))
    op.create_foreign_key('fk_subject_cohort_id_cohort', 'subject', 'cohort', ['cohort_id'], ['id'])
    op.add_column('transition', sa.Column('condition', sa.Text(), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('transition', 'condition')
    op.drop_constraint('fk_subject_cohort_id_cohort', 'subject', type_='foreignkey')
    op.drop_column('subject', 'cohort_id')
    op.add_column('state', sa.Column('callback', mysql.TEXT(), nullable=True))
    op.add_column('state', sa.Column('lifespan', mysql.INTEGER(display_width=11), autoincrement=False, nullable=True))

    op.create_table('transition_has_condition',
        sa.Column('transition_id', mysql.INTEGER(display_width=11), autoincrement=False, nullable=True),
        sa.Column('condition_id', mysql.INTEGER(display_width=11), autoincrement=False, nullable=True),
        sa.ForeignKeyConstraint(['condition_id'], ['condition.id'], name='fk_transition_has_condition_condition_id_condition'),
        sa.ForeignKeyConstraint(['transition_id'], ['transition.id'], name='fk_transition_has_condition_transition_id_transition'),
        mysql_default_charset='latin1',
        mysql_engine='InnoDB'
    )

    op.create_table('condition',
        sa.Column('id', mysql.INTEGER(display_width=11), autoincrement=True, nullable=False),
        sa.Column('rule', mysql.VARCHAR(length=500), nullable=False),
        sa.Column('freetext', mysql.TEXT(), nullable=True),
        sa.PrimaryKeyConstraint('id'),
        mysql_default_charset='latin1',
        mysql_engine='InnoDB'
    )

    op.drop_table('callback_execution')
    op.drop_table('variable')
    op.drop_table('callback')
    op.drop_table('external_system_history')
    op.drop_table('external_cohort_urls')
    op.drop_table('cohort')
    # ### end Alembic commands ###
